# Overview
`PREDICTOR` is a system capable of estimating the grounding size (number of ground rules in the grounded program) for non-ground answer set programs.

# Installation
There are 2 dependencies:
1. `PREDICTOR` requires Python 3 to run. It has been specifically tested on Python 3.7.4.
2. `Clingo 5` is needed. We recommend installing clingo into your python path through `Anaconda`. Install `Anaconda` for `Python` 3. `Anaconda` can be downloaded [here](https://www.anaconda.com/download/). Follow the instructions provided on the site for installation.

After installing the dependencies, `PREDICTOR` can be used through CLI (see below). The following step is necessary to use `PREDICTOR` as a Python library:

`PREDICTOR` can be installed onto your python path by running the following from this directory:
`python setup.py install`

# Using `PREDICTOR`
System `PREDICTOR` can be used either through CLI or as a Python library. We detail usage below. All examples are assumed to be ran from the `example` directory provided.
## Using the CLI
Help can be accessed using:
`python ../pd_cli.py -h`
### Example
`python ../pd_cli.py program.lp --predict_rules rule.lp --json`

## Using the Python Library
An example of using `PREDICTOR` can be seen in `example.py`. 

The example can be run using `python example.py`. 
Verify that the output is:
```
The size of the loaded program is: 9
The size of the rule is: 2
```
